#!/bin/sh
#
# php85-fpm	PHP FastCGI Process Manager
#
# chkconfig:	345 80 30
#
# description:	PHP FastCGI Process Manager
#
# processname:	php85-fpm
# config:	/etc/php85/php-fpm.conf
# pidfile:	/var/run/php85-fpm.pid
#

# Source function library
. /etc/rc.d/init.d/functions

# Get network config
. /etc/sysconfig/network

configfile=/etc/php85/php-fpm.conf
lockfile=/var/lock/subsys/php85-fpm
pidfile=$(sed -ne  's,^pid\s*=\s*\(.*\),\1,p' $configfile)
pidfile=${pidfile:-/var/run/php85-fpm.pid}

# configtest itself
# must return non-zero if check failed
# output is discarded if checkconfig is ran without details
configtest() {
	/usr/sbin/php85-fpm --fpm-config $configfile -t
	return $?
}

# wrapper for configtest
checkconfig() {
	local details=${1:-0}

	if [ $details = 1 ]; then
		# run config test and display report (status action)
		show "Checking %s configuration" "PHP FastCGI Process Manager"; busy
		local out
		out=$(configtest 2>&1)
		RETVAL=$?
		if [ $RETVAL = 0 ]; then
			ok
		else
			fail
		fi
		[ "$out" ] && echo >&2 "$out"
	else
		# run config test and abort with nice message if failed
		# (for actions checking status before action).
		configtest >/dev/null 2>&1
		RETVAL=$?
		if [ $RETVAL != 0 ]; then
			show "Checking %s configuration" "PHP FastCGI Process Manager"; fail
			nls 'Configuration test failed. See details with %s "checkconfig"' $0
			exit $RETVAL
		fi
	fi
}

start() {
	# Check if the service is already running?
	if [ -f $lockfile ]; then
		msg_already_running "PHP FastCGI Process Manager (php85-fpm)"
		return
	fi

	checkconfig
	msg_starting "PHP FastCGI Process Manager (php85-fpm)"
	daemon --redirfds --pidfile $pidfile /usr/sbin/php85-fpm --fpm-config $configfile
	RETVAL=$?
	[ $RETVAL -eq 0 ] && touch $lockfile
}

stop() {
	if [ ! -f $lockfile ]; then
		msg_not_running "PHP FastCGI Process Manager (php85-fpm)"
		return
	fi

	# Stop daemons.
	msg_stopping "PHP FastCGI Process Manager (php85-fpm)"
	# always gracefully shut down php85-fpm
	/sbin/start-stop-daemon -q --stop -s QUIT --retry QUIT/600/TERM/10 --pidfile $pidfile
	[ "$?" -eq 0 ] && ok || fail
	rm -f $lockfile
}

reload() {
	local sig=${1:-HUP}
	local retnr=${2:-7}
	if [ ! -f $lockfile ]; then
		msg_not_running "PHP FastCGI Process Manager (php85-fpm)"
		RETVAL=$retnr
		return
	fi

	checkconfig
	msg_reloading "PHP FastCGI Process Manager (php85-fpm)"
	killproc --pidfile $pidfile php85-fpm -$sig
	RETVAL=$?
}

condrestart() {
	if [ ! -f $lockfile ]; then
		msg_not_running "PHP FastCGI Process Manager (php85-fpm)"
		RETVAL=$1
		return
	fi

	checkconfig
	stop
	start
}

RETVAL=0
# See how we were called.
case "$1" in
  start)
  	start
	;;
  stop|quit)
  	stop
	;;
  restart)
	stop
	start
	;;
  try-restart)
	condrestart 0
	;;
  reload|force-reload)
	reload USR2 7
	;;
  checkconfig|configtest)
	checkconfig 1
	;;
  flush-logs|logrotate)
	reload USR1 0
	;;
  status)
	status  --pidfile $pidfile php85-fpm
	RETVAL=$?
	;;
  *)
	msg_usage "$0 {start|stop|restart|try-restart|reload|force-reload|flush-logs|checkconfig|status}"
	exit 3
	;;
esac

exit $RETVAL
